package de.unimarburg.swt.emf.metric;

import java.util.List;

import org.eclipse.emf.ecore.EObject;

import de.unimarburg.swt.emf.metrics.interfaces.ICalculateClass;
import de.unimarburg.swt.emf.metrics.model.Metric;
import de.unimarburg.swt.emf.metrics.operations.IOperation;
import de.unimarburg.swt.emf.metrics.operations.Operations;

public class Abstractness implements ICalculateClass {

	private List<EObject> context;
	private String metricID1 = "scm.nacp";
	private String metricID2 = "scm.tncp";

	IOperation operation = Operations.getOperation("Division");
	
	@Override
	public void setContext(List<EObject> context) {
		this.context = context;	
	}

	@Override
	public double calculate() {
		Metric metric1 = Metric.getMetricInstanceFromId(metricID1);
		Metric metric2 = Metric.getMetricInstanceFromId(metricID2);
		
		ICalculateClass calc1 = metric1.getCalculateClass();
		ICalculateClass calc2 = metric2.getCalculateClass();
			
		calc1.setContext(this.context);
		calc2.setContext(this.context);
		return operation.calculate(calc1.calculate(),calc2.calculate());
	}

}
