package de.unimarburg.swt.emf.metric;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.emf.ecore.EObject;

import simplifiedclassmodel.PackageableElement;
import simplifiedclassmodel.ScmClass;
import simplifiedclassmodel.ScmPackage;

import de.unimarburg.swt.emf.metrics.interfaces.ICalculateClass;

public class NACP implements ICalculateClass {

	private List<EObject> context;

	@Override
	public void setContext(List<EObject> context) {
		this.context=context;
	}

	@Override
	public double calculate() {
		ScmPackage p = (ScmPackage) context.get(0);
		return getAllAbstractClasses(p).size();
	}

	private List<ScmClass> getAllAbstractClasses(ScmPackage p) {
		List<ScmClass> abstractClasses = new ArrayList<ScmClass>();
		for (PackageableElement pe : p.getOwnedElement()) {
			if (pe instanceof ScmClass) {
				ScmClass cl = (ScmClass) pe;
				if (cl.isIsAbstract()) abstractClasses.add(cl);
			}
		}
		return abstractClasses;
	}

}
