package de.unimarburg.swt.emf.metric;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.emf.ecore.EObject;

import simplifiedclassmodel.Association;
import simplifiedclassmodel.PackageableElement;
import simplifiedclassmodel.ScmPackage;
import de.unimarburg.swt.emf.metrics.interfaces.ICalculateClass;

public class NASP implements ICalculateClass {

	private List<EObject> context;

	@Override
	public void setContext(List<EObject> context) {
		this.context=context;
	}

	@Override
	public double calculate() {
		ScmPackage p = (ScmPackage) context.get(0);
		return getAllAssociations(p).size();
	}

	private List<Association> getAllAssociations(ScmPackage p) {
		List<Association> associations = new ArrayList<Association>();
		for (PackageableElement pe : p.getOwnedElement()) {
			if (pe instanceof Association) {
				associations.add((Association) pe);
			}
		}
		return associations;
	}

}
