package de.unimarburg.swt.emf.metric;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.emf.ecore.EObject;

import simplifiedclassmodel.Attribute;
import simplifiedclassmodel.PackageableElement;
import simplifiedclassmodel.ScmClass;
import simplifiedclassmodel.ScmPackage;
import de.unimarburg.swt.emf.metrics.interfaces.ICalculateClass;

public class NOAP implements ICalculateClass {

	private List<EObject> context;

	@Override
	public void setContext(List<EObject> context) {
		this.context=context;
	}

	@Override
	public double calculate() {
		ScmPackage p = (ScmPackage) context.get(0);
		return getAllOwnedAttributes(p).size();
	}

	private List<Attribute> getAllOwnedAttributes(ScmPackage p) {
		List<ScmClass> classes = new ArrayList<ScmClass>();
		for (PackageableElement pe : p.getOwnedElement()) {
			if (pe instanceof ScmClass) {
				ScmClass cl = (ScmClass) pe; 
				if (! cl.isIsAbstract()) classes.add(cl);
			}
		}
		List<Attribute> attributes = new ArrayList<Attribute>();
		for (ScmClass cl : classes) {
			attributes.addAll(cl.getOwnedAttribute());
		}		
		return attributes;
	}

}
