package de.unimarburg.swt.emf.metric;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.emf.ecore.EObject;

import simplifiedclassmodel.PackageableElement;
import simplifiedclassmodel.ScmClass;
import simplifiedclassmodel.ScmPackage;
import de.unimarburg.swt.emf.metrics.interfaces.ICalculateClass;

public class TNCP implements ICalculateClass {
	
	private List<EObject> context;

	@Override
	public void setContext(List<EObject> context) {
		this.context=context;
	}

	@Override
	public double calculate() {
		ScmPackage p = (ScmPackage) context.get(0);
		return getAllClasses(p).size();
	}

	private List<ScmClass> getAllClasses(ScmPackage p) {
		List<ScmClass> classes = new ArrayList<ScmClass>();
		for (PackageableElement pe : p.getOwnedElement()) {
			if (pe instanceof ScmClass) {
				classes.add((ScmClass) pe);
			}
		}
		return classes;
	}
	
	public double foo() {
		ScmPackage p = (ScmPackage) context.get(0);
		int numberOfClasses = 0;
		for (PackageableElement pe : p.getOwnedElement()) {
			if (pe instanceof ScmClass) numberOfClasses++;
		}
		return numberOfClasses;
	}
	
	public void foo2() {
		ScmPackage scmModel = (ScmPackage) context.get(0);
		List<ScmClass> classes = getAllClasses(scmModel);
		for (ScmClass cl : classes) {
			if (cl.isIsAbstract() && getChildren(cl).size() == 1) {
				addToSmellOccurrences(cl);
			}
		}		
	}

	private void addToSmellOccurrences(ScmClass cl) {
		// TODO Auto-generated method stub
		
	}

	private List<ScmClass> getChildren(ScmClass cl) {
		// TODO Auto-generated method stub
		return null;
	}
	
	public boolean checkEachClassHasAttributes(List<ScmClass> classes) {
		for (ScmClass cl : classes) {
			if (cl.getOwnedAttribute().isEmpty()) {
				return false;
			}
		}
		return true;
	}

}
