/**
 * <copyright>
 * </copyright>
 *
 * $Id: RefactoringController.javajet,v 1.3 2011/01/21 13:08:06 tarendt Exp $
 */
package de.unimarburg.swt.scm.refactoringsnew.scm.stub;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.emf.common.util.TreeIterator;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.refactor.common.core.EmfRefactoring;
import org.eclipse.emf.refactor.common.core.IController;
import org.eclipse.emf.refactor.common.core.IDataManagement;
import org.eclipse.emf.refactor.runtime.ltk.LtkEmfRefactoringProcessorAdapter;
import org.eclipse.ltk.core.refactoring.RefactoringStatus;
import org.eclipse.ltk.core.refactoring.participants.RefactoringProcessor;

import simplifiedclassmodel.Generalization;
import simplifiedclassmodel.ScmClass;
import simplifiedclassmodel.ScmPackage;
import simplifiedclassmodel.SimplifiedclassmodelFactory;

public final class RefactoringController implements IController{

	/**
	 * EmfRefactoring supported by the controller.
	 * @generated
	 */
	private EmfRefactoring parent;
	
	/**
	 * DataManagement object of the model refactoring.
	 * @generated
	 */
	private RefactoringDataManagement dataManagement = 
									new RefactoringDataManagement();
	
	/**
	 * Invocation context of the model refactoring.
	 * @generated
	 */	
	private List<EObject> selection = new ArrayList<EObject>();
	
	/**
	 * Ltk RefactoringProcessor of the model refactoring.
	 * @generated
	 */
	private InternalRefactoringProcessor refactoringProcessor = null;
	
	/**
	 * Gets the EmfRefactoring supported by the controller.
	 * @return EmfRefactoring supported by the controller.
	 * @see org.eclipse.emf.refactor.common.core.IController#getParent()
	 * @generated
	 */
	@Override
	public EmfRefactoring getParent() {
		return this.parent;
	}
	
	/**
	 * Sets the EmfRefactoring supported by the controller.
	 * @param emfRefactoring EmfRefactoring supported by the controller.
	 * @see org.eclipse.emf.refactor.common.core.IController#
	 * setParent(org.eclipse.emf.refactor.common.core.EmfRefactoring)
	 * @generated
	 */
	@Override
	public void setParent(EmfRefactoring emfRefactoring) {
		this.parent = emfRefactoring;
	}
	
	/**
	 * Returns the DataManagement object of the model refactoring.
	 * @return DataManagement object of the model refactoring.
	 * @see org.eclipse.emf.refactor.common.core.IController#
	 * getDataManagementObject()
	 * @generated
	 */
	@Override
	public IDataManagement getDataManagementObject() {
		return this.dataManagement;
	}

	/**
	 * Returns the ltk RefactoringProcessor of the model refactoring.
	 * @return Ltk RefactoringProcessor of the model refactoring.
	 * @see org.eclipse.emf.refactor.common.core.IController#
	 * getLtkRefactoringProcessor()
	 * @generated
	 */
	@Override
	public RefactoringProcessor getLtkRefactoringProcessor() {
		return this.refactoringProcessor;
	}
	
	/**
	 * Sets the selected EObject (invocation context of the model refactoring).
	 * @param selection Invocation context of the model refactoring.
	 * @see org.eclipse.emf.refactor.common.core.IController#
	 * setSelection(java.util.List)
	 * @generated
	 */
	@Override
	public void setSelection(List<EObject> selection) {
		this.selection = selection;
		this.refactoringProcessor = 
				new InternalRefactoringProcessor(this.selection);
	}	
	
	/**
	 * Returns a Runnable object that executes the model refactoring.
	 * @return Runnable object that executes the model refactoring.
	 * @generated
	 */
	private Runnable applyRefactoring() {
		return new Runnable() {				
			/**
			 * @see java.lang.Runnable#run()
			 * @generated
			 */
			@Override
			public void run() {
				simplifiedclassmodel.ScmClass selectedEObject = 
					(ScmClass) dataManagement.getInPortByName(dataManagement.SELECTEDEOBJECT).getValue();
				String superclassname =
					(String) dataManagement.getInPortByName("superclassname").getValue();
				ScmClass superClass = searchExistingClassWithName(selectedEObject, superclassname);
				if (superClass == null) {
					ScmPackage owningPackage = selectedEObject.getOwningPackage();
					superClass = SimplifiedclassmodelFactory.eINSTANCE.createScmClass();
					superClass.setName(superclassname);
					owningPackage.getOwnedElement().add(0, superClass);
				}
				Generalization gen = SimplifiedclassmodelFactory.eINSTANCE.createGeneralization();
				selectedEObject.getGeneralization().add(gen);
				gen.setSpecific(selectedEObject);
				gen.setGeneral(superClass);
			}

			private ScmClass searchExistingClassWithName(
					ScmClass selectedEObject, String superclassname) {
				TreeIterator<EObject> iter = selectedEObject.eResource().getAllContents();
				while (iter.hasNext()) {
					EObject eObject = iter.next();
					if (eObject instanceof ScmClass) {
						ScmClass scmClass = (ScmClass) eObject;
						if (scmClass.getName().equals(superclassname)) {
							return scmClass;
						}
					}			
				}
				return null;
			}
		};
	}

	/**
	 * Internal class for providing an instance of a LTK RefactoringProcessor 
	 * used for EMF model refactorings.	 
	 * @generated
	 */
	public final class InternalRefactoringProcessor extends 
									LtkEmfRefactoringProcessorAdapter {

		/**
		 * Constructor using the invocation context of the model refactoring.
		 * @param selection Invocation context of the model refactoring.
		 * @generated
		 */
		private InternalRefactoringProcessor(List<EObject> selection){
				super(getParent(), selection, applyRefactoring());				
		}
			
		/**
		 * @see org.eclipse.ltk.core.refactoring.participants.RefactoringProcessor#
	 	 * checkInitialConditions(org.eclipse.core.runtime.IProgressMonitor)
		 * @generated
		 */	
		@Override
		public RefactoringStatus checkInitialConditions(){
				RefactoringStatus result = new RefactoringStatus();
				simplifiedclassmodel.ScmClass selectedEObject = 
					(simplifiedclassmodel.ScmClass) dataManagement.
							getInPortByName(dataManagement.SELECTEDEOBJECT).getValue();
				// stub
				result.addFatalError("Stub");
				return result;
		}
		
		/**
		 * @see org.eclipse.ltk.core.refactoring.participants.RefactoringProcessor#
	     * checkFinalConditions(org.eclipse.core.runtime.IProgressMonitor, 
	     * org.eclipse.ltk.core.refactoring.participants.CheckConditionsContext)
		 * @generated
		 */	
		@Override
		public RefactoringStatus checkFinalConditions(){
				RefactoringStatus result = new RefactoringStatus();
				simplifiedclassmodel.ScmClass selectedEObject = 
					(simplifiedclassmodel.ScmClass) dataManagement.
							getInPortByName(dataManagement.SELECTEDEOBJECT).getValue();
				String superclassname =
					(String) dataManagement.getInPortByName("superclassname").getValue();
				// TODO: implement final check
				return result;
		}
		
	}

}