package de.unimarburg.swt.emf.modelsmell;

import java.util.LinkedList;
import java.util.List;

import org.eclipse.emf.ecore.EObject;

import de.unimarburg.swt.emf.metrics.interfaces.ICalculateClass;
import de.unimarburg.swt.emf.metrics.model.Metric;
import de.unimarburg.swt.emf.modelsmell.abstractclasses.MetricBasedModelSmellFinderClass;

public class DataClumps extends MetricBasedModelSmellFinderClass {

	private Metric localMetric = Metric.getMetricInstanceFromId("scm.neac");
	
	@Override
	public LinkedList<LinkedList<EObject>> findSmell(EObject root) {
		LinkedList<EObject> rootList = new LinkedList<EObject>();
		rootList.add(root);
		ICalculateClass localCalculateClass = localMetric.getCalculateClass();
		double globalLimit = this.getLimit();
		return findSmellyObjectGroups(root, globalLimit, localCalculateClass);
	}
	
	private LinkedList<LinkedList<EObject>> findSmellyObjectGroups(EObject root, double globalLimit, 
				ICalculateClass localCalculateClass){
		String context = localMetric.getContext();
		LinkedList<LinkedList<EObject>> smellyEObjects = new LinkedList<LinkedList<EObject>>();
		List<EObject> containedEObjects = root.eContents();
		for(EObject object : containedEObjects){
			String objectType = object.eClass().getInstanceClassName();
			if(objectType.equals(context)){
				LinkedList<EObject> rootList = new LinkedList<EObject>();
				rootList.add(object);
				localCalculateClass.setContext(rootList);
				double localValue = localCalculateClass.calculate();
				if(localValue >= globalLimit){
					LinkedList<EObject> currentObjects = new LinkedList<EObject>();
					currentObjects.add(object);
					smellyEObjects.add((currentObjects));
				}
			}else{
				smellyEObjects.addAll(findSmellyObjectGroups(object, globalLimit, localCalculateClass));
			}
		}
		return smellyEObjects;
	}

}
