package de.unimarburg.swt.emf.metric;

import java.util.List;
import org.eclipse.emf.ecore.EObject;
import de.unimarburg.swt.emf.metrics.calculator.ocl.OCLUtils;
import de.unimarburg.swt.emf.metrics.interfaces.ICalculateClass;


public final class NumberofFeatures implements ICalculateClass {

	private final String expression = 
			"self.ownedAttribute -> size() + self.ownedOperation -> size()";	
	private List<EObject> context; 
		
	@Override
	public void setContext(List<EObject> context) {
		this.context = context;
	}	
		
	@Override
	public double calculate() {	
		EObject contextObject = context.get(0);
		return OCLUtils.evaluateOCLOnContextObject(contextObject, expression);
	}
}