package de.unimarburg.swt.uml.metrics.umlclass;

import java.util.List;
import org.eclipse.emf.ecore.EObject;
import de.unimarburg.swt.emf.metrics.calculator.ocl.OCLUtils;
import de.unimarburg.swt.emf.metrics.interfaces.ICalculateClass;

public final class DAC2 implements ICalculateClass {

	private final String expression = 
			"self.ownedAttribute.type -> asSet() -> select(c|c <> null) " +
			"-> select(oclIsTypeOf(Class)) -> size()";	
	private List<EObject> context; 
		
	@Override
	public void setContext(List<EObject> context) {
		this.context=context;
	}	
		
	@Override
	public double calculate() {	
		EObject contextObject = context.get(0);
		return OCLUtils.evaluateOCLOnContextObject(contextObject, expression);
	}
}