package de.unimarburg.swt.uml.metrics.umlmodel;



import java.util.ArrayList;
import java.util.List;

import org.eclipse.emf.common.util.TreeIterator;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.uml2.uml.Class;

import de.unimarburg.swt.emf.metrics.interfaces.ICalculateClass;
import de.unimarburg.swt.emf.metrics.model.Metric;


public final class NACM implements ICalculateClass {

		
	private List<EObject> context; 
	private String metricId = "de.unimarburg.swt.metrics.uml.nsupc2";
		
	@Override
	public void setContext(List<EObject> context) {
		this.context=context;
	}	
		
	@Override
	public double calculate() {	
		Double result = 0.0;
		Metric metric = Metric.getMetricInstanceFromId(metricId);
		ICalculateClass calc = metric.getCalculateClass();
		TreeIterator<EObject> iter = context.get(0).eResource().getAllContents();
		while (iter.hasNext()) {
			EObject eObject = iter.next();
			if (eObject instanceof Class) {
				ArrayList<EObject> context = new ArrayList<EObject>();
				context.add(eObject);
				calc.setContext(context);
				result += calc.calculate();
			}			
		}
		return result;
	}
}