package de.unimarburg.swt.uml.metrics.umlpackage;

import java.io.IOException;
import java.net.URL;
import java.util.Collections;
import java.util.List;
import java.util.Stack;
import org.eclipse.core.runtime.FileLocator;
import org.eclipse.core.runtime.Path;
import org.eclipse.emf.ecore.EObject;
import de.unimarburg.swt.emf.metrics.calculator.henshin.HenshinUtils;
import de.unimarburg.swt.emf.metrics.interfaces.ICompositeCalculateClass;
import de.unimarburg.swt.emf.metrics.model.HenshinTransformationsPack;
import de.unimarburg.swt.emf.metrics.operations.*;


public final class NAP implements ICompositeCalculateClass {

	private final HenshinTransformationsPack[] transformations = { new HenshinTransformationsPack(
			"",
			getFullPath("transformations/nap.henshin"),
			"")}; 
		
	private List<EObject> context; 
		
	@Override
	public void setContext(List<EObject> context) {
		this.context=context;
	}	
		
	@Override
	public double calculate() {
		Stack<Double> valStack = new Stack<Double>();
		for(HenshinTransformationsPack transformation : transformations){
			valStack.push(value(transformation));
		}
		return valStack.pop();
	}
	
	@Override
	public String getCalculateOperation() {
		return "valStack.pop()";
	}

	public HenshinTransformationsPack[] getTransformationPacks(){
		return transformations;
	}
	
	public IOperation[] getOperations(){
		return null;
	}
	
	private String getFullPath(String transformationPath){
		URL url = FileLocator.find(de.unimarburg.swt.uml.metrics.Activator.getDefault().getBundle(), new Path(transformationPath), Collections.EMPTY_MAP);
		URL fileUrl = null;
		try {
		fileUrl = FileLocator.toFileURL(url);
		}
		catch (IOException e) {
			e.printStackTrace();
		}
		return 	fileUrl.getPath();
	}
	
	private double value(HenshinTransformationsPack transformations){
		return HenshinUtils.run(transformations, this.context);
	}
	
}